/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.domain.dto.CarbonFootprintDTO
 *  com.deepexi.scd.calculate.domain.query.CarbonFootprintQuery
 *  com.deepexi.scd.calculate.domain.query.CarbonFootprintTaskProductSkuQuery
 *  com.deepexi.scd.calculate.domain.request.CarbonFootprintReportGenerateRequest
 *  com.deepexi.scd.calculate.domain.request.FootprintCertifiedProductReq
 *  com.deepexi.scd.calculate.domain.request.FootprintCollectAuditReq
 *  com.deepexi.scd.calculate.domain.request.FootprintConfirmResultReq
 *  com.deepexi.scd.calculate.domain.vo.FootprintReportWebVO
 *  com.deepexi.scd.calculate.service.CarbonFootprintService
 *  com.deepexi.scd.common.annotation.ContextFlag
 *  com.deepexi.spa.commons.data.Payload
 *  io.swagger.annotations.Api
 *  io.swagger.annotations.ApiOperation
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.validation.annotation.Validated
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.deepexi.scd.calculate.controller;

import com.deepexi.scd.calculate.domain.dto.CarbonFootprintDTO;
import com.deepexi.scd.calculate.domain.query.CarbonFootprintQuery;
import com.deepexi.scd.calculate.domain.query.CarbonFootprintTaskProductSkuQuery;
import com.deepexi.scd.calculate.domain.request.CarbonFootprintReportGenerateRequest;
import com.deepexi.scd.calculate.domain.request.FootprintCertifiedProductReq;
import com.deepexi.scd.calculate.domain.request.FootprintCollectAuditReq;
import com.deepexi.scd.calculate.domain.request.FootprintConfirmResultReq;
import com.deepexi.scd.calculate.domain.vo.FootprintReportWebVO;
import com.deepexi.scd.calculate.service.CarbonFootprintService;
import com.deepexi.scd.common.annotation.ContextFlag;
import com.deepexi.spa.commons.data.Payload;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Api(tags={"碳足迹表"})
@RequestMapping(value={"/admin-api/v1/carbonFootprint"})
public class CarbonFootprintController {
    @Autowired
    private CarbonFootprintService carbonFootprintService;

    @ApiOperation(value="获取详情")
    @GetMapping(value={"/{carbonFootprintId}"})
    public Payload<CarbonFootprintDTO> getById(@PathVariable(value="carbonFootprintId") Long carbonFootprintId) {
        return Payload.ok((Object)this.carbonFootprintService.getById(carbonFootprintId));
    }

    @ApiOperation(value="获取详情(包含sku列表)")
    @PostMapping(value={"/containSku/{footprintId}"})
    public Payload<CarbonFootprintDTO> detail(@RequestBody CarbonFootprintTaskProductSkuQuery query, @PathVariable Long footprintId) {
        return Payload.ok((Object)this.carbonFootprintService.detail(footprintId, query.getSkuCodeList()));
    }

    @ApiOperation(value="报告预览")
    @GetMapping(value={"/report/preview/{id}"})
    public Payload<FootprintReportWebVO> reportPreview(@PathVariable Long id) {
        return Payload.ok((Object)this.carbonFootprintService.reportPreview(id));
    }

    @ApiOperation(value="生成报告")
    @PostMapping(value={"/report/generate"})
    public Payload<Boolean> generateReport(@Validated @RequestBody CarbonFootprintReportGenerateRequest req) {
        return Payload.ok((Object)this.carbonFootprintService.generateReport(req));
    }

    @ApiOperation(value="报告下载")
    @GetMapping(value={"/report/download/{id}"})
    public void reportDownload(HttpServletResponse response, @PathVariable Long id) throws IOException {
        this.carbonFootprintService.reportDownload(response, id);
    }

    @ApiOperation(value="采集审核-202311")
    @PostMapping(value={"/collectAudit"})
    public Payload<Boolean> collectAudit(@Validated @RequestBody FootprintCollectAuditReq req) {
        return Payload.ok((Object)this.carbonFootprintService.collectAudit(req));
    }

    @ApiOperation(value="核算认证端-确认核算结果-202311")
    @PostMapping(value={"/confirmCalculateResult"})
    public Payload<Boolean> confirmCalculateResult(@Validated @RequestBody FootprintConfirmResultReq req) {
        return Payload.ok((Object)this.carbonFootprintService.confirmCalculateResult(req));
    }

    @ApiOperation(value="企业端-认证产品")
    @PostMapping(value={"/certifiedProduct"})
    public Payload<Boolean> certifiedProduct(@Validated @RequestBody FootprintCertifiedProductReq req) {
        return Payload.ok((Object)this.carbonFootprintService.certifiedProduct(req));
    }

    @ApiOperation(value="企业端-碳足迹列表")
    @GetMapping(value={"/enterprise/paging"})
    public Payload<CarbonFootprintDTO> enterpriseFindPage(CarbonFootprintQuery query) {
        return Payload.ok((Object)this.carbonFootprintService.findJoinPage(query));
    }

    @ApiOperation(value="认证端--碳足迹列表")
    @GetMapping(value={"/paging"})
    @ContextFlag(value="ignoreTenant")
    public Payload<CarbonFootprintDTO> findPage(CarbonFootprintQuery query) {
        return Payload.ok((Object)this.carbonFootprintService.findJoinPage(query));
    }

    @ApiOperation(value="认证端--碳足迹列表--导出")
    @GetMapping(value={"/export"})
    @ContextFlag(value="ignoreTenant")
    public void export(HttpServletResponse response, CarbonFootprintQuery query) {
        this.carbonFootprintService.export(response, query);
    }
}

